// Forlix SoScore
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs


public Action:JoinTeam(client, args)
{
  if(!IsClientInGame(client))
    return(Plugin_Continue);

  new team = -1;

  decl String:argstr[4];
  argstr[0] = '\0';

  GetCmdArgString(argstr, sizeof(argstr));

  if(IsCharNumeric(argstr[0])
  && argstr[1] == '\0')
    team = argstr[0]-0x30;

  new oldteam = GetClientTeam(client);

  if(team == CS_TEAM_SPECTATOR)
    return(Plugin_Continue);
  else
  if(team == CS_TEAM_T
  || team == CS_TEAM_CT)
  {
    if(team == oldteam)
    {
      p_classmenublocks[client] = false;
      return(Plugin_Continue);
    }

    if(team_limit
    && GetTeamClientCount(team) >= team_limit)
    {
      TeamChooseRetry(client);

      switch(team)
      {
        case CS_TEAM_T:
        PrintCenterText(client, "#Terrorists_Full");

        case CS_TEAM_CT:
        PrintCenterText(client, "#CTs_Full");
      }

      return(Plugin_Handled);
    }
    else
      p_classmenublocks[client] = true;
  }
  else
  if(team == 0)
  {
    new autoassign = 0;

    if(p_teamchooselock[client])
    // player locked to team, auto assign to it
      autoassign = p_teamchooselock[client];
    else
    {
      new t_numplayers = GetTeamClientCount(CS_TEAM_T);
      new ct_numplayers = GetTeamClientCount(CS_TEAM_CT);

      if(t_numplayers < ct_numplayers)
      {
        if(!team_limit
        || t_numplayers < team_limit)
          autoassign = CS_TEAM_T;
      }
      else
      if(t_numplayers > ct_numplayers)
      {
        if(!team_limit
        || ct_numplayers < team_limit)
          autoassign = CS_TEAM_CT;
      }
      else
      // both teams are of equal size
      {
        if(oldteam > CS_TEAM_SPECTATOR)
          autoassign = oldteam;
        else
        if(!team_limit
        || t_numplayers < team_limit)
        // both teams are below the team limit
        {
          new t_score = GetTeamScore(CS_TEAM_T);
          new ct_score = GetTeamScore(CS_TEAM_CT);

          if(t_score < ct_score)
            autoassign = CS_TEAM_T;
          else
          if(t_score > ct_score)
            autoassign = CS_TEAM_CT;
          else
          // both team scores are equal, choose randomly
            autoassign = GetRandomInt(CS_TEAM_T, CS_TEAM_CT);
        }
      }
    }

    if(autoassign)
      FakeClientCommand(client, "jointeam %u", autoassign);
    else
    {
      TeamChooseRetry(client);
      PrintCenterText(client, "#All_Teams_Full");
    }

    return(Plugin_Handled);
  }
  else
    return(Plugin_Handled);

  return(Plugin_Continue);
}


TeamChooseRetry(client)
{
  static Float:time_ljt[MAXPLAYERS+1];
  new Float:time_c = GetTickedTime();

  if(time_c >= time_ljt[client] + 0.3)
    ShowVGUIPanel(client, "team");

  time_ljt[client] = time_c;
  return;
}


public Action:JoinClass(client, args)
{
  p_choosingclass[client] = false;
  RequestPlayerSpawn(client);

  return(Plugin_Continue);
}


public Action:UserMsg_VGUIMenu(UserMsg:msg_id,
                               Handle:bf,
                               const players[],
                               playersnum,
                               bool:reliable,
                               bool:init)
{
  decl String:type[16];

  if(playersnum != 1
  || BfReadString(bf, type, sizeof(type)) <= 0
  || type[0] != 'c')
    return(Plugin_Continue);

  new client = players[0];

  if(!strcmp(type, "class_ter")
  || !strcmp(type, "class_ct"))
  {
    if(IsFakeClient(client))
    // bots never send joinclass
      RequestPlayerSpawn(client);
    else
    if(p_classmenublocks[client])
    {
      p_choosingclass[client] = true;
      p_teamchooselock[client] = GetClientTeam(client);
    }
  }

  return(Plugin_Continue);
}
